<?php

declare(strict_types=1);

namespace Dedi\SyliusMigrationPlugin\DependencyInjection\Compiler;

use Symfony\Component\DependencyInjection\Compiler\CompilerPassInterface;
use Symfony\Component\DependencyInjection\ContainerBuilder;

class TransformerPass implements CompilerPassInterface
{
    public function process(ContainerBuilder $container): void
    {
        $transformerRegistryDefinition = $container->getDefinition('dedi_migration_transformer_registry');

        $serviceIds = $container->findTaggedServiceIds('dedi_migration_transformer');

        foreach ($serviceIds as $serviceId => $tags) {
            $transformerDefinition = $container->getDefinition($serviceId);
            $transformerRegistryDefinition->addMethodCall('addTransformer', [$transformerDefinition]);
        }
    }
}
